program make_mod
character (len=32) :: mod_name
character (len=132),target :: base1(200),base2(200),base3(200),base4(200)
character (len=132) :: temp1,temp2
character (len=132),pointer:: text(:)
character (len=32) :: rname(10),ftype(10),mpitype(10),shmemtype(10)
character (len=15) :: ranks(0:7)
character (len=15) :: one(0:7)
character (len=3)  :: zone(0:7)
character (len=32)infile,outfile
integer ::  start1,end1,start2,end2,end_max
 character (len=1),allocatable::did_it(:,:)
 character (len=1)::tab
logical :: same
ranks = (/"               ","(:)            ",&
          "(:,:)          ","(:,:,:)        ",&
          "(:,:,:,:)      ","(:,:,:,:,:)    ",&
          "(:,:,:,:,:,:)  ","(:,:,:,:,:,:,:)"/)
one =   (/"               ","(:)            ",&
          "(:,1)          ","(:,1,1)        ",&
          "(:,1,1,1)      ","(:,1,1,1,1)    ",&
          "(:,1,1,1,1,1)  ","(:,1,1,1,1,1,1)"/)
zone=   (/"   ",            "(:)",&
          "(:)",            "(:)",&
          "(:)",            "(:)",&
          "(:)",            "(:)"/)
tab=char(9)
read(*,"(a)")temp1
i1=index(temp1," ")
i2=len_trim(temp1)
read(temp1(1:i1-1),"(a)")infile
read(temp1(i1+1:i2),"(a)")outfile
write(*,*)infile,outfile
open(12,file=infile)
open(13,file=outfile)
read(12,*)same
read(12,*)mod_name
read(12,*)start1,end1,start2,end2
i=0
do itmp=1,10
    read(12,"(a)")base1(1)
    !if(index(base1(1) ,"!") .ne. 0)cycle
    i=i+1
    if(index(base1(1) ,"subroutine") .ne. 0 .or. &
       index(base1(1) ,"function") .ne. 0)then
        n=i-1
        exit
    endif
    i0=1
    i4=len_trim(base1(1))
    i3=i4
    k=0
    do j=1,i4
    	if(ichar(base1(1)(j:j)) .eq. ichar(' '))then
    		if(k .eq. 0)i1=j
    		if(k .eq. 1)i2=j
    		if(k .eq. 2)i3=j
    		k=k+1
    	endif
    enddo
    read(base1(1)(i0:i1-1),"(a)")rname(i)
    i1=i1+1
    read(base1(1)(i1:i2-1),"(a)")ftype(i)
    i2=i2+1
    if(k .eq. 3)then
    	read(base1(1)(i2:i3-1),"(a)")mpitype(i)
    	i3=i3+1
    	read(base1(1)(i3:i4),"(a)")shmemtype(i)
    else
    	read(base1(1)(i2:i4),"(a)")mpitype(i)
    	shmemtype(i)=""
    endif
!    write(*,*)"!",i0,i1,i2,i3,i4
!    write(*,*)"!",rname(i),ftype(i),mpitype(i),shmemtype(i)
enddo
!base1 rank input .eq. 0 .and.  rank output .eq. 0
do i=2,200
    read(12,"(a)")base1(i)
    if(index(base1(i) ,"end subroutine") .ne. 0 .or. &
       index(base1(i) ,"end function") .ne. 0)then
        l1=i
        exit
    endif
enddo
!base2 rank input .ne. 0 .and.  rank output .ne. 0
do i=1,200
    read(12,"(a)")base2(i)
    if(index(base2(i) ,"end subroutine") .ne. 0 .or. &
       index(base2(i) ,"end function") .ne. 0)then
        l2=i
        exit
    endif
enddo
                if(index(base1(3),"same") .ne. 0)then
                    do i=1,l2
                         base1(i)=base2(i)
                    enddo
                    l1=l2
                endif


!!base3 rank input .ne. 0 .and.  rank output .eq. 0
!    do i=1,200
!        read(12,"(a)")base3(i)
!        if(index(base3(i) ,"end subroutine") .ne. 0)then
!            l3=i
!            exit
!        endif
!    enddo
!!base4 rank input .eq. 0 .and.  rank output .ne. 0
!    do i=1,200
!        read(12,"(a)")base4(i)
!        if(index(base4(i) ,"end subroutine") .ne. 0)then
!            l4=i
!            exit
!        endif
!    enddo
write(13,*)"!************************"
write(13,"(""module ccm_"",a,""_mod"")")trim(mod_name)
write(13,"(""    public :: ccm_"",a)")trim(mod_name)
write(13,"(""    interface ccm_"",a)")trim(mod_name)
end_max=max(end1,end2)
allocate(did_it(0:end_max,0:end_max))
did_it="n"
do k=1,n
    do i=start1,end1
        do j=start2,end2
            if(same .and. (j .ne. i))cycle
            did_it(i,j)="y"
            if(index(rname(k),"!").ne. 0)cycle
            write(13,"(8x,""module procedure "",a,""_"",a,i1,i1)")trim(mod_name),trim(rname(k)),i,j
        enddo
    enddo
enddo
write(13,*)"    end interface"
write(13,*)"    contains"
open(14,file="build_report",status="unknown",position="append")
write(14,*)"<table>"
write(14,"(a,a,a)",advance="no")"<tr><td><b>",trim(mod_name),"</b></td>"
do j=start2,end2
    if(j .ne. end2) then
        write(14,"(a,i1,a)",advance="no")"<td><b>",j,"</b></td>"
    else
       write(14,"(a,i1,a)")"<td><b>",j,"</b></td></tr>"
    endif
enddo
do i=start1,end1
	write(14,"(a,i1,a)",advance="no")"<tr><td><b>",i,"</b></td>"
	do j=start2,end2
		if(j .ne. end2) then
			write(14,"(a,a,a)",advance="no")"<td>",did_it(i,j),"</td>"
		else
			write(14,"(a,a,a)")"<td>",did_it(i,j),"</td></tr>"
		endif
	enddo
enddo
write(14,*)"</table>"
write(14,*)"<table>"
write(14,"(a,a,a)",advance="no")"<tr><td><b>",trim(mod_name),"</b></td>"
do k=1,n
		if(index(rname(k),"!").ne. 0)cycle
			write(14,"(a,a,a)",advance="no")"<td>",trim(ftype(k)),"</td>"
	enddo
			write(14,"(a)")"</tr>"

write(14,*)"</table>"
close(14)
do k=1,n
    if(index(rname(k),"!").ne. 0)cycle
    do i=start1,end1
        do j=start2,end2
            if(same .and. (j .ne. i))cycle
            if(i .eq. 0 .and. j .eq. 0)then
                text=>base1
                nl=l1
            else
                text=>base2
                nl=l2
            endif
!            if(i .ne. 0 .and. j .ne. 0)then
!                text=>base2
!                nl=l2
!            endif
!            if(i .eq. 0 .and. j .ne. 0)then
!                text=>base2
!                nl=l3
!                cycle
!            endif
!            if(i .ne. 0 .and. j .eq. 0)then
!                text=>base2
!                nl=l4
!                cycle
!            endif
            do l=1,nl
                write(temp1,"(a)")trim(text(l))
				if((index(temp1,"! r1=0") .ne. 0) .and. (i .ne. 0))cycle
				if((index(temp1,"! r1>0") .ne. 0) .and. (i .eq. 0))cycle
				if((index(temp1,"! r2=0") .ne. 0) .and. (j .ne. 0))cycle
				if((index(temp1,"! r2>0") .ne. 0) .and. (j .eq. 0))cycle
                do while (index(temp1,"$1") .ne. 0)
                ! $1 == mod_name
                    in=index(temp1,"$1")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(mod_name),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$2") .ne. 0)
                ! $2 == routine name with ranks
                    in=index(temp1,"$2")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,2i1,a)")(temp1(1:in-1)),trim(rname(k)),i,j,trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$h") .ne. 0)
                ! $2 == routine name with ranks
                    in=index(temp1,"$h")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(rname(k)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$3") .ne. 0)
                ! $3 == data type
                    in=index(temp1,"$3")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(ftype(k)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$4") .ne. 0)
                ! $4 == input data rank
                    in=index(temp1,"$4")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(ranks(i)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$5") .ne. 0)
                ! $5 == output data rank
                    in=index(temp1,"$5")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")trim(temp1(1:in-1)),trim(ranks(j)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$f") .ne. 0)
                ! $f == input data rank
                    in=index(temp1,"$f")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(one(i)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$j") .ne. 0)
                ! $j == pointer rank
                    in=index(temp1,"$j")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(zone(j)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$k") .ne. 0)
                ! $k == pointer rank
                    in=index(temp1,"$k")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")(temp1(1:in-1)),trim(zone(i)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$g") .ne. 0)
                ! $g == output data rank
                    in=index(temp1,"$g")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")trim(temp1(1:in-1)),trim(one(j)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$6") .ne. 0)
                ! $6 == mpitype
                    in=index(temp1,"$6")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")trim(temp1(1:in-1)),trim(mpitype(k)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$i") .ne. 0)
                ! $i == shmemtype
                    in=index(temp1,"$i")
                    len=len_trim(temp1)
                    write(temp2,"(a,a,a)")trim(temp1(1:in-1)),trim(shmemtype(k)),trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$l") .ne. 0)
                ! $l == i
                    in=index(temp1,"$l")
                    len=len_trim(temp1)
                    write(temp2,"(a,i1,a)")trim(temp1(1:in-1)),i,trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
                do while (index(temp1,"$m") .ne. 0)
                ! $l == j
                    in=index(temp1,"$m")
                    len=len_trim(temp1)
                    write(temp2,"(a,i1,a)")trim(temp1(1:in-1)),j,trim(temp1(in+2:len))
                    write(temp1,"(a)")trim(temp2)
                enddo
            write(13,*)trim(temp1)
            enddo
        enddo
    enddo
enddo
write(13,*)"end module"

end program
    


